﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;

namespace _2012_04_10_17_24_Praktikum_Loesung
{
    public partial class MainWindow : Window
    {
        DispatcherTimer timer = new DispatcherTimer();

        Car[] cars = new Car[20];

        public MainWindow()
        {
            InitializeComponent();

            timer.Interval = TimeSpan.FromSeconds(0.02);
            timer.Tick += animate;
            timer.IsEnabled = true;

            Random r = new Random();
            for (int i = 0; i < cars.Length; i++)
            {
                bool tooClose;
                do
                {
                    cars[i] = new Car(r.NextDouble(), 0.1 + 0.05 * r.NextDouble());
                    tooClose = false;
                    for (int j = 0; j < i; j++)
                    {
                        if (cars[i].FollowsTooClose(cars[j]) || cars[j].FollowsTooClose(cars[i]))
                        {
                            tooClose = true;
                            break;
                        }
                    }
                }
                while (tooClose);
            }
        }

        void animate(object sender, EventArgs e)
        {
            for (int i = 0; i < cars.Length; i++) // besser: foreach
            {
                cars[i].Drive(timer.Interval.TotalSeconds, cars);
            }

            const double size = 200.0;

            myCanvas.Children.Clear();
            Ellipse ellipse = new Ellipse();
            ellipse.Width = size;
            ellipse.Height = size;
            ellipse.Stroke = Brushes.Blue;
            ellipse.StrokeThickness = 1.0;
            myCanvas.Children.Add(ellipse);
            Canvas.SetLeft(ellipse, 20.0); // besser: diese 20.0 als Konstante und auch bei cars[i].Draw übergeben
            Canvas.SetTop(ellipse, 20.0);

            for (int i = 0; i < cars.Length; i++) // besser: foreach
            {
                cars[i].Draw(myCanvas, size);
            }
        }
    }
}
